# Class DefaultProcedureTranslator

java.lang.Object
org.apache.cayenne.access.translator.procedure.DefaultProcedureTranslator

All Implemented Interfaces:
  `ProcedureTranslator`

Direct Known Subclasses:
  `HSQLDBProcedureTranslator, MySQLProcedureTranslator, PostgresProcedureTranslator`

public class DefaultProcedureTranslator extends Object implements ProcedureTranslator
A `ProcedureTranslator` returned by the base `JdbcAdapter`. Adapters may subclass it to customize the generated call string.

Since:
  5.0

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultProcedureTranslator()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected CSParameter<?>`
  `createBinding(DbAdapter adapter, ProcedureParameter param, Map<String,?> queryValues, int position)`
  Builds a `CSParameter` for a single call parameter.
  `protected String`
  `createSqlString(Procedure procedure, int callParamsSize)`
  Creates an SQL String for the stored procedure call.
  `TranslatedProcedure`
  `translate(ProcedureQuery query, DbAdapter adapter, EntityResolver resolver)`
  Translates the provided query into a `TranslatedProcedure`.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### DefaultProcedureTranslator

    public DefaultProcedureTranslator()

- ## Method Details

  - ### translate

    public TranslatedProcedure translate(ProcedureQuery query, DbAdapter adapter, EntityResolver resolver)
    Description copied from interface: `ProcedureTranslator`
    Translates the provided query into a `TranslatedProcedure`.
    Specified by:
      `translate` in interface `ProcedureTranslator`

  - ### createBinding

    protected CSParameter<?> createBinding(DbAdapter adapter, ProcedureParameter param, Map<String,?> queryValues, int position)
    Builds a `CSParameter` for a single call parameter. IN (and INOUT) parameters carry the actual value and its `ExtendedType`; pure OUT parameters carry an "[OUT]" marker value so that logging renders nicely.

  - ### createSqlString

    protected String createSqlString(Procedure procedure, int callParamsSize)
    Creates an SQL String for the stored procedure call.